﻿namespace UltraGridComboInColumnHeader
{
    using System;
    using System.Drawing;
    using System.Windows.Forms;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinGrid;

    internal class CF : IUIElementCreationFilter
    {
        private OptionButtonUIElement radioABC = null;
        private OptionButtonUIElement radioPQR = null;

        public void AfterCreateChildElements(UIElement parent)
        {
            var headerElement = parent as HeaderUIElement;
            if (headerElement != null)
            {
                if (headerElement.Header.Caption == "PercentOfFirst" ||
                    headerElement.Header.Caption == "PercentOfSecond")
                {

                    radioABC = new OptionButtonUIElement(headerElement);
                    radioABC.Text = "ABC";
                    radioABC.Rect = new Rectangle(
                        headerElement.Rect.Location,
                        new Size(
                            headerElement.Rect.Width / 2,
                            headerElement.Rect.Height));
                    parent.ChildElements.Add(radioABC);

                    radioABC.ElementClick += RadioABC_ElementClick;

                    radioPQR = new OptionButtonUIElement(headerElement);
                    radioPQR.Text = "PQR";
                    radioPQR.Rect = new Rectangle(
                        headerElement.Rect.Left + headerElement.Rect.Width / 2,
                        headerElement.Rect.Top,
                        headerElement.Rect.Width / 2,
                        headerElement.Rect.Height);
                    parent.ChildElements.Add(radioPQR);

                    radioPQR.ElementClick += RadioPQR_ElementClick;
                }

                if (headerElement.Header.Caption == "PercentOfFirst")
                {
                    radioABC.CheckState = CheckState.Checked;
                    radioPQR.CheckState = CheckState.Unchecked;
                }

                if (headerElement.Header.Caption == "PercentOfSecond")
                {
                    radioABC.CheckState = CheckState.Unchecked;
                    radioPQR.CheckState = CheckState.Checked;
                }
            }
        }

        private void RadioPQR_ElementClick(object sender, UIElementEventArgs e)
        {
            if (this.radioPQR.CheckState == CheckState.Unchecked)
            {
                var abcColumn = ((HeaderUIElement)this.radioPQR.Parent).Header.Column;
                abcColumn.Hidden = true;

                var pqrColumn = abcColumn.Band.Columns["PercentOfSecond"];
                pqrColumn.Hidden = false;

                this.radioPQR.CheckState = CheckState.Checked;
                this.radioABC.CheckState = CheckState.Unchecked;
            }
        }

        private void RadioABC_ElementClick(object sender, UIElementEventArgs e)
        {
            if (this.radioABC.CheckState == CheckState.Unchecked)
            {
                var pqrColumn = ((HeaderUIElement)this.radioABC.Parent).Header.Column;
                pqrColumn.Hidden = true;

                var abcColumn = pqrColumn.Band.Columns["PercentOfFirst"];
                abcColumn.Hidden = false;


                this.radioABC.CheckState = CheckState.Checked;
                this.radioPQR.CheckState = CheckState.Unchecked;

            }
        }

        private void Editor_ValueChanged(object sender, EventArgs e)
        {
            throw new NotImplementedException();
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}